<?php
/**
 * Automatically generated by running "php schema.php bcmath".
 *
 * You may modify the file, but re-running schema.php against this file will
 * standardize the format without losing your schema changes. It does lose
 * any changes that are not part of schema. Use "note" field to comment on
 * schema itself, and "note" fields are not used in any code generation but
 * only staying within this file.
 */
///////////////////////////////////////////////////////////////////////////////
// Preamble: C++ code inserted at beginning of ext_{name}.h

DefinePreamble(<<<CPP

CPP
);

///////////////////////////////////////////////////////////////////////////////
// Constants
//
// array (
//   'name' => name of the constant
//   'type' => type of the constant
//   'note' => additional note about this constant's schema
// )


///////////////////////////////////////////////////////////////////////////////
// Functions
//
// array (
//   'name'   => name of the function
//   'desc'   => description of the function's purpose
//   'flags'  => attributes of the function, see base.php for possible values
//   'opt'    => optimization callback function's name for compiler
//   'note'   => additional note about this function's schema
//   'return' =>
//      array (
//        'type'  => return type, use Reference for ref return
//        'desc'  => description of the return value
//      )
//   'args'   => arguments
//      array (
//        'name'  => name of the argument
//        'type'  => type of the argument, use Reference for output parameter
//        'value' => default value of the argument
//        'desc'  => description of the argument
//      )
// )

DefineFunction(
  array(
    'name'   => "bcscale",
    'desc'   => "Sets the default scale parameter for all subsequent bc math functions that do not explicitly specify a scale parameter.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "scale",
        'type'   => Int64,
        'desc'   => "The scale factor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcadd",
    'desc'   => "Sums left_operand and right_operand.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "The sum of the two operands, as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The right operand, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "This optional parameter is used to set the number of digits after the decimal place in the result. You can also set the global default scale for all functions by using bcscale().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcsub",
    'desc'   => "Subtracts the right_operand from the left_operand.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "The result of the subtraction, as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The right operand, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "This optional parameter is used to set the number of digits after the decimal place in the result. You can also set the global default scale for all functions by using bcscale().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bccomp",
    'desc'   => "Compares the left_operand to the right_operand and returns the result as an integer.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64,
      'desc'   => "Returns 0 if the two operands are equal, 1 if the left_operand is larger than the right_operand, -1 otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The right operand, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "The optional scale parameter is used to set the number of digits after the decimal place which will be used in the comparison.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcmul",
    'desc'   => "Multiply the left_operand by the right_operand.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the result as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The right operand, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "This optional parameter is used to set the number of digits after the decimal place in the result. You can also set the global default scale for all functions by using bcscale().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcdiv",
    'desc'   => "Divides the left_operand by the right_operand.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the result of the division as a string, or NULL if right_operand is 0.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The right operand, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "This optional parameter is used to set the number of digits after the decimal place in the result. You can also set the global default scale for all functions by using bcscale().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcmod",
    'desc'   => "Get the modulus of the left_operand using modulus.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the modulus as a string, or NULL if modulus is 0.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The modulus, as a string.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcpow",
    'desc'   => "Raise left_operand to the power right_operand.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the result as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The right operand, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "This optional parameter is used to set the number of digits after the decimal place in the result. You can also set the global default scale for all functions by using bcscale().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcpowmod",
    'desc'   => "Use the fast-exponentiation method to raise left_operand to the power right_operand with respect to the modulus modulus.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the result as a string, or NULL if modulus is 0.",
    ),
    'args'   => array(
      array(
        'name'   => "left",
        'type'   => String,
        'desc'   => "The left operand, as a string.",
      ),
      array(
        'name'   => "right",
        'type'   => String,
        'desc'   => "The right operand, as a string.",
      ),
      array(
        'name'   => "modulus",
        'type'   => String,
        'desc'   => "The modulus, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "This optional parameter is used to set the number of digits after the decimal place in the result. You can also set the global default scale for all functions by using bcscale().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "bcsqrt",
    'desc'   => "Return the square root of the operand.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the square root as a string, or NULL if operand is negative.",
    ),
    'args'   => array(
      array(
        'name'   => "operand",
        'type'   => String,
        'desc'   => "The operand, as a string.",
      ),
      array(
        'name'   => "scale",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "This optional parameter is used to set the number of digits after the decimal place in the result. You can also set the global default scale for all functions by using bcscale().",
      ),
    ),
  ));


///////////////////////////////////////////////////////////////////////////////
// Classes
//
// BeginClass
// array (
//   'name'   => name of the class
//   'desc'   => description of the class's purpose
//   'flags'  => attributes of the class, see base.php for possible values
//   'note'   => additional note about this class's schema
//   'parent' => parent class name, if any
//   'ifaces' => array of interfaces tihs class implements
//   'bases'  => extra internal and special base classes this class requires
//   'footer' => extra C++ inserted at end of class declaration
// )
//
// DefineConstant(..)
// DefineConstant(..)
// ...
// DefineFunction(..)
// DefineFunction(..)
// ...
// DefineProperty
// DefineProperty
//
// array (
//   'name'  => name of the property
//   'type'  => type of the property
//   'flags' => attributes of the property
//   'desc'  => description of the property
//   'note'  => additional note about this property's schema
// )
//
// EndClass()

