<?php
/**
 * Automatically generated by running "php schema.php image".
 *
 * You may modify the file, but re-running schema.php against this file will
 * standardize the format without losing your schema changes. It does lose
 * any changes that are not part of schema. Use "note" field to comment on
 * schema itself, and "note" fields are not used in any code generation but
 * only staying within this file.
 */
///////////////////////////////////////////////////////////////////////////////
// Preamble: C++ code inserted at beginning of ext_{name}.h

DefinePreamble(<<<CPP

CPP
);

///////////////////////////////////////////////////////////////////////////////
// Constants
//
// array (
//   'name' => name of the constant
//   'type' => type of the constant
//   'note' => additional note about this constant's schema
// )


///////////////////////////////////////////////////////////////////////////////
// Functions
//
// array (
//   'name'   => name of the function
//   'desc'   => description of the function's purpose
//   'flags'  => attributes of the function, see base.php for possible values
//   'opt'    => optimization callback function's name for compiler
//   'note'   => additional note about this function's schema
//   'return' =>
//      array (
//        'type'  => return type, use Reference for ref return
//        'desc'  => description of the return value
//      )
//   'args'   => arguments
//      array (
//        'name'  => name of the argument
//        'type'  => type of the argument, use Reference for output parameter
//        'value' => default value of the argument
//        'desc'  => description of the argument
//      )
// )

DefineFunction(
  array(
    'name'   => "gd_info",
    'desc'   => "Gets information about the version and capabilities of the installed GD library.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
    ),
  ));

DefineFunction(
  array(
    'name'   => "getimagesize",
    'desc'   => "The getimagesize() function will determine the size of any given image file and return the dimensions along with the file type and a height/width text string to be used inside a normal HTML IMG tag and the correspondant HTTP content type.\n\ngetimagesize() can also return some more information in imageinfo parameter. Note that JPC and JP2 are capable of having components with different bit depths. In this case, the value for \"bits\" is the highest bit depth encountered. Also, JP2 files may contain multiple JPEG 2000 codestreams. In this case, getimagesize() returns the values for the first codestream it encounters in the root of the file. The information about icons are retrieved from the icon with the highest bitrate.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "This parameter specifies the file you wish to retrieve information about. It can reference a local file or (configuration permitting) a remote file using one of the supported streams.",
      ),
      array(
        'name'   => "imageinfo",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "This optional parameter allows you to extract some extended information from the image file. Currently, this will return the different JPG APP markers as an associative array. Some programs use these APP markers to embed text information in images. A very common one is to embed  IPTC information in the APP13 marker. You can use the iptcparse() function to parse the binary APP13 marker into something readable.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "image_type_to_extension",
    'desc'   => "Returns the extension for the given IMAGETYPE_XXX constant.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "A string with the extension corresponding to the given image type.",
    ),
    'args'   => array(
      array(
        'name'   => "imagetype",
        'type'   => Int32,
        'desc'   => "One of the IMAGETYPE_XXX constant.",
      ),
      array(
        'name'   => "include_dot",
        'type'   => Boolean,
        'value'  => "true",
        'desc'   => "Whether to prepend a dot to the extension or not. Default to TRUE.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "image_type_to_mime_type",
    'desc'   => "The image_type_to_mime_type() function will determine the Mime-Type for an IMAGETYPE constant.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "The returned values are as follows Returned values Constants imagetype Returned value IMAGETYPE_GIF image/gif IMAGETYPE_JPEG image/jpeg IMAGETYPE_PNG image/png IMAGETYPE_SWF application/x-shockwave-flash IMAGETYPE_PSD image/psd IMAGETYPE_BMP image/bmp IMAGETYPE_TIFF_II (intel byte order) image/tiff IMAGETYPE_TIFF_MM (motorola byte order) image/tiff IMAGETYPE_JPC application/octet-stream IMAGETYPE_JP2 image/jp2 IMAGETYPE_JPX application/octet-stream IMAGETYPE_JB2 application/octet-stream IMAGETYPE_SWC application/x-shockwave-flash IMAGETYPE_IFF image/iff IMAGETYPE_WBMP image/vnd.wap.wbmp IMAGETYPE_XBM image/xbm IMAGETYPE_ICO image/vnd.microsoft.icon",
    ),
    'args'   => array(
      array(
        'name'   => "imagetype",
        'type'   => Int32,
        'desc'   => "One of the IMAGETYPE_XXX constants.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "image2wbmp",
    'desc'   => "image2wbmp() outputs or save a WBMP version of the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "Path to the saved file. If not given, the raw image stream will be outputted directly.",
      ),
      array(
        'name'   => "threshold",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "Threshold value, between 0 and 255 (inclusive).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagealphablending",
    'desc'   => "imagealphablending() allows for two different modes of drawing on truecolor images. In blending mode, the alpha channel component of the color supplied to all drawing function, such as imagesetpixel() determines how much of the underlying color should be allowed to shine through. As a result, gd automatically blends the existing color at that point with the drawing color, and stores the result in the image. The resulting pixel is opaque. In non-blending mode, the drawing color is copied literally with its alpha channel information, replacing the destination pixel. Blending mode is not available when drawing on palette images.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "blendmode",
        'type'   => Boolean,
        'desc'   => "Whether to enable the blending mode or not. On true color images the default value is TRUE otherwise the default value is FALSE",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageantialias",
    'desc'   => "Activate the fast drawing antialiased methods for lines and wired polygons. It does not support alpha components. It works using a direct blend operation. It works only with truecolor images.\n\nThickness and styled are not supported.\n\nUsing antialiased primitives with transparent background color can end with some unexpected results. The blend method uses the background color as any other colors. The lack of alpha component support does not allow an alpha based antialiasing method.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "on",
        'type'   => Boolean,
        'desc'   => "Whether to enable antialiasing or not.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagearc",
    'desc'   => "imagearc() draws an arc of circle centered at the given coordinates.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "cx",
        'type'   => Int32,
        'desc'   => "x-coordinate of the center.",
      ),
      array(
        'name'   => "cy",
        'type'   => Int32,
        'desc'   => "y-coordinate of the center.",
      ),
      array(
        'name'   => "width",
        'type'   => Int32,
        'desc'   => "The arc width.",
      ),
      array(
        'name'   => "height",
        'type'   => Int32,
        'desc'   => "The arc height.",
      ),
      array(
        'name'   => "start",
        'type'   => Int32,
        'desc'   => "The arc start angle, in degrees.",
      ),
      array(
        'name'   => "end",
        'type'   => Int32,
        'desc'   => "The arc end angle, in degrees. 0° is located at the three-o'clock position, and the arc is drawn clockwise.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagechar",
    'desc'   => "imagechar() draws the first character of c in the image identified by image with its upper-left at x,y (top left is 0, 0) with the color color.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "font",
        'type'   => Int32,
        'desc'   => "Can be 1, 2, 3, 4, 5 for built-in fonts in latin2 encoding (where higher numbers corresponding to larger fonts) or any of your own font identifiers registered with imageloadfont().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate of the start.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate of the start.",
      ),
      array(
        'name'   => "c",
        'type'   => String,
        'desc'   => "The character to draw.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecharup",
    'desc'   => "Draws the character c vertically at the specified coordinate on the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "font",
        'type'   => Int32,
        'desc'   => "Can be 1, 2, 3, 4, 5 for built-in fonts in latin2 encoding (where higher numbers corresponding to larger fonts) or any of your own font identifiers registered with imageloadfont().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate of the start.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate of the start.",
      ),
      array(
        'name'   => "c",
        'type'   => String,
        'desc'   => "The character to draw.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorallocate",
    'desc'   => "Returns a color identifier representing the color composed of the given RGB components.\n\nimagecolorallocate() must be called to create each color that is to be used in the image represented by image.\n\nThe first call to imagecolorallocate() fills the background color in palette-based images - images created using imagecreate().\nThese parameters are integers between 0 and 255 or hexadecimals between 0x00 and 0xFF.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "A color identifier or FALSE if the allocation failed.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorallocatealpha",
    'desc'   => "imagecolorallocatealpha() behaves identically to imagecolorallocate() with the addition of the transparency parameter alpha.\nThe colors parameters are integers between 0 and 255 or hexadecimals between 0x00 and 0xFF.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "A color identifier or FALSE if the allocation failed.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
      array(
        'name'   => "alpha",
        'type'   => Int32,
        'desc'   => "A value between 0 and 127. 0 indicates completely opaque while 127 indicates completely transparent.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorat",
    'desc'   => "Returns the index of the color of the pixel at the specified location in the image specified by image.\n\nIf PHP is compiled against GD library 2.0 or higher and the image is a truecolor image, this function returns the RGB value of that pixel as integer. Use bitshifting and masking to access the distinct red, green and blue component values:",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the index of the color.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate of the point.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate of the point.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorclosest",
    'desc'   => "Returns the index of the color in the palette of the image which is \"closest\" to the specified RGB value.\n\nThe \"distance\" between the desired color and each color in the palette is calculated as if the RGB values represented points in three-dimensional space.\n\nIf you created the image from a file, only colors used in the image are resolved. Colors present only in the palette are not resolved.\nThe colors parameters are integers between 0 and 255 or hexadecimals between 0x00 and 0xFF.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the index of the closest color, in the palette of the image, to the specified one",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorclosestalpha",
    'desc'   => "Returns the index of the color in the palette of the image which is \"closest\" to the specified RGB value and alpha level.\nThe colors parameters are integers between 0 and 255 or hexadecimals between 0x00 and 0xFF.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the index of the closest color in the palette.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
      array(
        'name'   => "alpha",
        'type'   => Int32,
        'desc'   => "A value between 0 and 127. 0 indicates completely opaque while 127 indicates completely transparent.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorclosesthwb",
    'desc'   => "Get the index of the color which has the hue, white and blackness nearest the given color.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an integer with the index of the color which has the hue, white and blackness nearest the given color.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolordeallocate",
    'desc'   => "De-allocates a color previously allocated with imagecolorallocate() or imagecolorallocatealpha().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The color identifier.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorexact",
    'desc'   => "Returns the index of the specified color in the palette of the image.\n\nIf you created the image from a file, only colors used in the image are resolved. Colors present only in the palette are not resolved.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the index of the specified color in the palette, or -1 if the color does not exist.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorexactalpha",
    'desc'   => "Returns the index of the specified color+alpha in the palette of the image.\nThe colors parameters are integers between 0 and 255 or hexadecimals between 0x00 and 0xFF.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the index of the specified color+alpha in the palette of the image, or -1 if the color does not exist in the image's palette.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
      array(
        'name'   => "alpha",
        'type'   => Int32,
        'desc'   => "A value between 0 and 127. 0 indicates completely opaque while 127 indicates completely transparent.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolormatch",
    'desc'   => "Makes the colors of the palette version of an image more closely match the true color version.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image1",
        'type'   => Resource,
        'desc'   => "A truecolor image link resource.",
      ),
      array(
        'name'   => "image2",
        'type'   => Resource,
        'desc'   => "A palette image link resource pointing to an image that has the same size as image1.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorresolve",
    'desc'   => "This function is guaranteed to return a color index for a requested color, either the exact color or the closest possible alternative.\n\nIf you created the image from a file, only colors used in the image are resolved. Colors present only in the palette are not resolved.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a color index.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorresolvealpha",
    'desc'   => "This function is guaranteed to return a color index for a requested color, either the exact color or the closest possible alternative.\nThe colors parameters are integers between 0 and 255 or hexadecimals between 0x00 and 0xFF.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a color index.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
      array(
        'name'   => "alpha",
        'type'   => Int32,
        'desc'   => "A value between 0 and 127. 0 indicates completely opaque while 127 indicates completely transparent.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorset",
    'desc'   => "This sets the specified index in the palette to the specified color. This is useful for creating flood-fill-like effects in palleted images without the overhead of performing the actual flood-fill.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "No value is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "index",
        'type'   => Int32,
        'desc'   => "An index in the palette.",
      ),
      array(
        'name'   => "red",
        'type'   => Int32,
        'desc'   => "Value of red component.",
      ),
      array(
        'name'   => "green",
        'type'   => Int32,
        'desc'   => "Value of green component.",
      ),
      array(
        'name'   => "blue",
        'type'   => Int32,
        'desc'   => "Value of blue component.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorsforindex",
    'desc'   => "Gets the color for a specified index.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an associative array with red, green, blue and alpha keys that contain the appropriate values for the specified color index.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "index",
        'type'   => Int32,
        'desc'   => "The color index.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolorstotal",
    'desc'   => "Returns the number of colors in an image palette.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the number of colors in the specified image's palette or 0 for truecolor images.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatefromgif().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecolortransparent",
    'desc'   => "Sets the transparent color in the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "The identifier of the new (or current, if none is specified) transparent color is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageconvolution",
    'desc'   => "Applies a convolution matrix on the image, using the given coefficient and offset.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "matrix",
        'type'   => Int64Map,
        'desc'   => "A 3x3 matrix: an array of three arrays of three floats.",
      ),
      array(
        'name'   => "div",
        'type'   => Double,
        'desc'   => "The divisor of the result of the convolution, used for normalization.",
      ),
      array(
        'name'   => "offset",
        'type'   => Double,
        'desc'   => "Color offset.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecopy",
    'desc'   => "Copy a part of src_im onto dst_im starting at the x,y coordinates src_x, src_y with a width of src_w and a height of src_h. The portion defined will be copied onto the x,y coordinates, dst_x and dst_y.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "dst_im",
        'type'   => Resource,
        'desc'   => "Destination image link resource.",
      ),
      array(
        'name'   => "src_im",
        'type'   => Resource,
        'desc'   => "Source image link resource.",
      ),
      array(
        'name'   => "dst_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of destination point.",
      ),
      array(
        'name'   => "dst_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of destination point.",
      ),
      array(
        'name'   => "src_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of source point.",
      ),
      array(
        'name'   => "src_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of source point.",
      ),
      array(
        'name'   => "src_w",
        'type'   => Int32,
        'desc'   => "Source width.",
      ),
      array(
        'name'   => "src_h",
        'type'   => Int32,
        'desc'   => "Source height.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecopymerge",
    'desc'   => "Copy a part of src_im onto dst_im starting at the x,y coordinates src_x, src_y with a width of src_w and a height of src_h. The portion defined will be copied onto the x,y coordinates, dst_x and dst_y.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "dst_im",
        'type'   => Resource,
        'desc'   => "Destination image link resource.",
      ),
      array(
        'name'   => "src_im",
        'type'   => Resource,
        'desc'   => "Source image link resource.",
      ),
      array(
        'name'   => "dst_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of destination point.",
      ),
      array(
        'name'   => "dst_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of destination point.",
      ),
      array(
        'name'   => "src_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of source point.",
      ),
      array(
        'name'   => "src_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of source point.",
      ),
      array(
        'name'   => "src_w",
        'type'   => Int32,
        'desc'   => "Source width.",
      ),
      array(
        'name'   => "src_h",
        'type'   => Int32,
        'desc'   => "Source height.",
      ),
      array(
        'name'   => "pct",
        'type'   => Int32,
        'desc'   => "The two images will be merged according to pct which can range from 0 to 100. When pct = 0, no action is taken, when 100 this function behaves identically to imagecopy() for pallete images, while it implements alpha transparency for true colour images.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecopymergegray",
    'desc'   => "imagecopymergegray() copy a part of src_im onto dst_im starting at the x,y coordinates src_x, src_y with a width of src_w and a height of src_h. The portion defined will be copied onto the x,y coordinates, dst_x and dst_y.\n\nThis function is identical to imagecopymerge() except that when merging it preserves the hue of the source by converting the destination pixels to gray scale before the copy operation.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "dst_im",
        'type'   => Resource,
        'desc'   => "Destination image link resource.",
      ),
      array(
        'name'   => "src_im",
        'type'   => Resource,
        'desc'   => "Source image link resource.",
      ),
      array(
        'name'   => "dst_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of destination point.",
      ),
      array(
        'name'   => "dst_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of destination point.",
      ),
      array(
        'name'   => "src_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of source point.",
      ),
      array(
        'name'   => "src_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of source point.",
      ),
      array(
        'name'   => "src_w",
        'type'   => Int32,
        'desc'   => "Source width.",
      ),
      array(
        'name'   => "src_h",
        'type'   => Int32,
        'desc'   => "Source height.",
      ),
      array(
        'name'   => "pct",
        'type'   => Int32,
        'desc'   => "The src_im will be changed to grayscale according to pct where 0 is fully grayscale and 100 is unchanged. When pct = 100 this function behaves identically to imagecopy() for pallete images, while it implements alpha transparency for true colour images.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecopyresampled",
    'desc'   => "imagecopyresampled() copies a rectangular portion of one image to another image, smoothly interpolating pixel values so that, in particular, reducing the size of an image still retains a great deal of clarity.\n\nIn other words, imagecopyresampled() will take an rectangular area from src_image of width src_w and height src_h at position (src_x,src_y) and place it in a rectangular area of dst_image of width dst_w and height dst_h at position (dst_x,dst_y).\n\nIf the source and destination coordinates and width and heights differ, appropriate stretching or shrinking of the image fragment will be performed. The coordinates refer to the upper left corner. This function can be used to copy regions within the same image (if dst_image is the same as src_image) but if the regions overlap the results will be unpredictable.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "dst_im",
        'type'   => Resource,
        'desc'   => "Destination image link resource.",
      ),
      array(
        'name'   => "src_im",
        'type'   => Resource,
        'desc'   => "Source image link resource.",
      ),
      array(
        'name'   => "dst_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of destination point.",
      ),
      array(
        'name'   => "dst_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of destination point.",
      ),
      array(
        'name'   => "src_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of source point.",
      ),
      array(
        'name'   => "src_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of source point.",
      ),
      array(
        'name'   => "dst_w",
        'type'   => Int32,
        'desc'   => "Destination width.",
      ),
      array(
        'name'   => "dst_h",
        'type'   => Int32,
        'desc'   => "Destination height.",
      ),
      array(
        'name'   => "src_w",
        'type'   => Int32,
        'desc'   => "Source width.",
      ),
      array(
        'name'   => "src_h",
        'type'   => Int32,
        'desc'   => "Source height.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecopyresized",
    'desc'   => "imagecopyresized() copies a rectangular portion of one image to another image. dst_image is the destination image, src_image is the source image identifier.\n\nIn other words, imagecopyresized() will take an rectangular area from src_image of width src_w and height src_h at position (src_x,src_y) and place it in a rectangular area of dst_image of width dst_w and height dst_h at position (dst_x,dst_y).\n\nIf the source and destination coordinates and width and heights differ, appropriate stretching or shrinking of the image fragment will be performed. The coordinates refer to the upper left corner. This function can be used to copy regions within the same image (if dst_image is the same as src_image) but if the regions overlap the results will be unpredictable.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "dst_im",
        'type'   => Resource,
        'desc'   => "Destination image link resource.",
      ),
      array(
        'name'   => "src_im",
        'type'   => Resource,
        'desc'   => "Source image link resource.",
      ),
      array(
        'name'   => "dst_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of destination point.",
      ),
      array(
        'name'   => "dst_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of destination point.",
      ),
      array(
        'name'   => "src_x",
        'type'   => Int32,
        'desc'   => "x-coordinate of source point.",
      ),
      array(
        'name'   => "src_y",
        'type'   => Int32,
        'desc'   => "y-coordinate of source point.",
      ),
      array(
        'name'   => "dst_w",
        'type'   => Int32,
        'desc'   => "Destination width.",
      ),
      array(
        'name'   => "dst_h",
        'type'   => Int32,
        'desc'   => "Destination height.",
      ),
      array(
        'name'   => "src_w",
        'type'   => Int32,
        'desc'   => "Source width.",
      ),
      array(
        'name'   => "src_h",
        'type'   => Int32,
        'desc'   => "Source height.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreate",
    'desc'   => "imagecreate() returns an image identifier representing a blank image of specified size.\n\nWe recommend the use of imagecreatetruecolor().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "width",
        'type'   => Int32,
        'desc'   => "The image width.",
      ),
      array(
        'name'   => "height",
        'type'   => Int32,
        'desc'   => "The image height.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromgd2part",
    'desc'   => "Create a new image from a given part of GD2 file or URL. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the GD2 image.",
      ),
      array(
        'name'   => "srcx",
        'type'   => Int32,
        'desc'   => "x-coordinate of source point.",
      ),
      array(
        'name'   => "srcy",
        'type'   => Int32,
        'desc'   => "y-coordinate of source point.",
      ),
      array(
        'name'   => "width",
        'type'   => Int32,
        'desc'   => "Source width.",
      ),
      array(
        'name'   => "height",
        'type'   => Int32,
        'desc'   => "Source height.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromgd",
    'desc'   => "Create a new image from GD file or URL. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the GD file.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromgd2",
    'desc'   => "Create a new image from GD2 file or URL. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the GD2 image.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromgif",
    'desc'   => "imagecreatefromgif() returns an image identifier representing the image obtained from the given filename. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the GIF image.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromjpeg",
    'desc'   => "imagecreatefromjpeg() returns an image identifier representing the image obtained from the given filename. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the JPEG image.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefrompng",
    'desc'   => "imagecreatefrompng() returns an image identifier representing the image obtained from the given filename. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the PNG image.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromstring",
    'desc'   => "imagecreatefromstring() returns an image identifier representing the image obtained from the given data. These types will be automatically detected if your build of PHP supports them: JPEG, PNG, GIF, WBMP, and GD2.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "An image resource will be returned on success. FALSE is returned if the image type is unsupported, the data is not in a recognised format, or the image is corrupt and cannot be loaded.",
    ),
    'args'   => array(
      array(
        'name'   => "data",
        'type'   => String,
        'desc'   => "A string containing the image data.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromwbmp",
    'desc'   => "imagecreatefromwbmp() returns an image identifier representing the image obtained from the given filename. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the WBMP image.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromxbm",
    'desc'   => "imagecreatefromxbm() returns an image identifier representing the image obtained from the given filename. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the XBM image.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatefromxpm",
    'desc'   => "imagecreatefromxpm() returns an image identifier representing the image obtained from the given filename. TipA URL can be used as a filename with this function if the fopen wrappers have been enabled. See fopen() for more details on how to specify the filename. See the List of Supported Protocols/Wrappers for links to information about what abilities the various wrappers have, notes on their usage, and information on any predefined variables they may provide.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the XPM image.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagecreatetruecolor",
    'desc'   => "imagecreatetruecolor() returns an image identifier representing a black image of the specified size.\n\nDepending on your PHP and GD versions this function is defined or not. With PHP 4.0.6 through 4.1.x this function always exists if the GD module is loaded, but calling it without GD2 being installed PHP will issue a fatal error and exit. With PHP 4.2.x this behaviour is different in issuing a warning instead of an error. Other versions only define this function, if the correct GD version is installed.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "width",
        'type'   => Int32,
        'desc'   => "Image width.",
      ),
      array(
        'name'   => "height",
        'type'   => Int32,
        'desc'   => "Image height.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagedashedline",
    'desc'   => "This function is deprecated. Use combination of imagesetstyle() and imageline() instead.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Always returns true",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x1",
        'type'   => Int32,
        'desc'   => "Upper left x coordinate.",
      ),
      array(
        'name'   => "y1",
        'type'   => Int32,
        'desc'   => "Upper left y coordinate 0, 0 is the top left corner of the image.",
      ),
      array(
        'name'   => "x2",
        'type'   => Int32,
        'desc'   => "Bottom right x coordinate.",
      ),
      array(
        'name'   => "y2",
        'type'   => Int32,
        'desc'   => "Bottom right y coordinate.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The fill color. A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagedestroy",
    'desc'   => "imagedestroy() frees any memory associated with image image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageellipse",
    'desc'   => "Draws an ellipse centered at the specified coordinates.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "cx",
        'type'   => Int32,
        'desc'   => "x-coordinate of the center.",
      ),
      array(
        'name'   => "cy",
        'type'   => Int32,
        'desc'   => "y-coordinate of the center.",
      ),
      array(
        'name'   => "width",
        'type'   => Int32,
        'desc'   => "The ellipse width.",
      ),
      array(
        'name'   => "height",
        'type'   => Int32,
        'desc'   => "The ellipse height.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The color of the ellipse. A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefill",
    'desc'   => "Performs a flood fill starting at the given coordinate (top left is 0, 0) with the given color in the image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate of start point.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate of start point.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The fill color. A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefilledarc",
    'desc'   => "Draws a partial arc centered at the specified coordinate in the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "cx",
        'type'   => Int32,
        'desc'   => "x-coordinate of the center.",
      ),
      array(
        'name'   => "cy",
        'type'   => Int32,
        'desc'   => "y-coordinate of the center.",
      ),
      array(
        'name'   => "width",
        'type'   => Int32,
        'desc'   => "The arc width.",
      ),
      array(
        'name'   => "height",
        'type'   => Int32,
        'desc'   => "The arc height.",
      ),
      array(
        'name'   => "start",
        'type'   => Int32,
        'desc'   => "The arc start angle, in degrees.",
      ),
      array(
        'name'   => "end",
        'type'   => Int32,
        'desc'   => "The arc end angle, in degrees. 0° is located at the three-o'clock position, and the arc is drawn clockwise.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
      array(
        'name'   => "style",
        'type'   => Int32,
        'desc'   => "A bitwise OR of the following possibilities: IMG_ARC_PIE IMG_ARC_CHORD IMG_ARC_NOFILL IMG_ARC_EDGED IMG_ARC_PIE and IMG_ARC_CHORD are mutually exclusive; IMG_ARC_CHORD just connects the starting and ending angles with a straight line, while IMG_ARC_PIE produces a rounded edge. IMG_ARC_NOFILL indicates that the arc or chord should be outlined, not filled. IMG_ARC_EDGED, used together with IMG_ARC_NOFILL, indicates that the beginning and ending angles should be connected to the center - this is a good way to outline (rather than fill) a 'pie slice'.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefilledellipse",
    'desc'   => "Draws an ellipse centered at the specified coordinate on the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "cx",
        'type'   => Int32,
        'desc'   => "x-coordinate of the center.",
      ),
      array(
        'name'   => "cy",
        'type'   => Int32,
        'desc'   => "y-coordinate of the center.",
      ),
      array(
        'name'   => "width",
        'type'   => Int32,
        'desc'   => "The ellipse width.",
      ),
      array(
        'name'   => "height",
        'type'   => Int32,
        'desc'   => "The ellipse height.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The fill color. A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefilledpolygon",
    'desc'   => "imagefilledpolygon() creates a filled polygon in the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "points",
        'type'   => VariantVec,
        'desc'   => "An array containing the x and y coordinates of the polygons vertices consecutively.",
      ),
      array(
        'name'   => "num_points",
        'type'   => Int32,
        'desc'   => "Total number of vertices, which must be at least 3.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefilledrectangle",
    'desc'   => "Creates a rectangle filled with color in the given image starting at point 1 and ending at point 2. 0, 0 is the top left corner of the image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x1",
        'type'   => Int32,
        'desc'   => "x-coordinate for point 1.",
      ),
      array(
        'name'   => "y1",
        'type'   => Int32,
        'desc'   => "y-coordinate for point 1.",
      ),
      array(
        'name'   => "x2",
        'type'   => Int32,
        'desc'   => "x-coordinate for point 2.",
      ),
      array(
        'name'   => "y2",
        'type'   => Int32,
        'desc'   => "y-coordinate for point 2.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The fill color. A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefilltoborder",
    'desc'   => "imagefilltoborder() performs a flood fill whose border color is defined by border. The starting point for the fill is x, y (top left is 0, 0) and the region is filled with color color.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate of start.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate of start.",
      ),
      array(
        'name'   => "border",
        'type'   => Int32,
        'desc'   => "The border color. A color identifier created with imagecolorallocate().",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The fill color. A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefilter",
    'desc'   => "imagefilter() applies the given filter filtertype on the image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filtertype",
        'type'   => Int32,
        'desc'   => "filtertype can be one of the following: IMG_FILTER_NEGATE: Reverses all colors of the image. IMG_FILTER_GRAYSCALE: Converts the image into grayscale. IMG_FILTER_BRIGHTNESS: Changes the brightness of the image. Use arg1 to set the level of brightness. IMG_FILTER_CONTRAST: Changes the contrast of the image. Use arg1 to set the level of contrast. IMG_FILTER_COLORIZE: Like IMG_FILTER_GRAYSCALE, except you can specify the color. Use arg1, arg2 and arg3 in the form of red, blue, green and arg4 for the alpha channel. The range for each color is 0 to 255. IMG_FILTER_EDGEDETECT: Uses edge detection to highlight the edges in the image. IMG_FILTER_EMBOSS: Embosses the image. IMG_FILTER_GAUSSIAN_BLUR: Blurs the image using the Gaussian method. IMG_FILTER_SELECTIVE_BLUR: Blurs the image. IMG_FILTER_MEAN_REMOVAL: Uses mean removal to achieve a \"sketchy\" effect. IMG_FILTER_SMOOTH: Makes the image smoother. Use arg1 to set the level of smoothness. IMG_FILTER_PIXELATE: Applies pixelation effect to the image, use arg1 to set the block size and arg2 to set the pixelation effect mode.",
      ),
      array(
        'name'   => "arg1",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "IMG_FILTER_BRIGHTNESS: Brightness level. IMG_FILTER_CONTRAST: Contrast level. IMG_FILTER_COLORIZE: Value of red component. IMG_FILTER_SMOOTH: Smoothness level. IMG_FILTER_PIXELATE: Block size in pixels.",
      ),
      array(
        'name'   => "arg2",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "IMG_FILTER_COLORIZE: Value of green component. IMG_FILTER_PIXELATE: Whether to use advanced pixelation effect or not (defaults to FALSE).",
      ),
      array(
        'name'   => "arg3",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "IMG_FILTER_COLORIZE: Value of blue component.",
      ),
      array(
        'name'   => "arg4",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "IMG_FILTER_COLORIZE: Alpha channel, A value between 0 and 127. 0 indicates completely opaque while 127 indicates completely transparent.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefontheight",
    'desc'   => "Returns the pixel height of a character in the specified font.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the height of the pixel.",
    ),
    'args'   => array(
      array(
        'name'   => "font",
        'type'   => Int32,
        'desc'   => "Can be 1, 2, 3, 4, 5 for built-in fonts in latin2 encoding (where higher numbers corresponding to larger fonts) or any of your own font identifiers registered with imageloadfont().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefontwidth",
    'desc'   => "Returns the pixel width of a character in font.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the width of the pixel",
    ),
    'args'   => array(
      array(
        'name'   => "font",
        'type'   => Int32,
        'desc'   => "Can be 1, 2, 3, 4, 5 for built-in fonts in latin2 encoding (where higher numbers corresponding to larger fonts) or any of your own font identifiers registered with imageloadfont().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageftbbox",
    'desc'   => "This function calculates and returns the bounding box in pixels for a FreeType text.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "imageftbbox() returns an array with 8 elements representing four points making the bounding box of the text: 0 lower left corner, X position 1 lower left corner, Y position 2 lower right corner, X position 3 lower right corner, Y position 4 upper right corner, X position 5 upper right corner, Y position 6 upper left corner, X position 7 upper left corner, Y position\n\nThe points are relative to the text regardless of the angle, so \"upper left\" means in the top left-hand corner seeing the text horizontally.",
    ),
    'args'   => array(
      array(
        'name'   => "size",
        'type'   => Double,
        'desc'   => "The font size. Depending on your version of GD, this should be specified as the pixel size (GD1) or point size (GD2).",
      ),
      array(
        'name'   => "angle",
        'type'   => Double,
        'desc'   => "Angle in degrees in which text will be measured.",
      ),
      array(
        'name'   => "font_file",
        'type'   => String,
        'desc'   => "The name of the TrueType font file (can be a URL). Depending on which version of the GD library that PHP is using, it may attempt to search for files that do not begin with a leading '/' by appending '.ttf' to the filename and searching along a library-defined font path.",
      ),
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "The string to be measured.",
      ),
      array(
        'name'   => "extrainfo",
        'type'   => VariantMap,
        'value'  => "null",
        'desc'   => "Possible array indexes for extrainfo Key Type Meaning linespacing float Defines drawing linespacing",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagefttext",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "This function returns an array defining the four points of the box, starting in the lower left and moving counter-clockwise: 0 lower left x-coordinate 1 lower left y-coordinate 2 lower right x-coordinate 3 lower right y-coordinate 4 upper right x-coordinate 5 upper right y-coordinate 6 upper left x-coordinate 7 upper left y-coordinate",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "size",
        'type'   => Double,
        'desc'   => "The font size to use in points.",
      ),
      array(
        'name'   => "angle",
        'type'   => Double,
        'desc'   => "The angle in degrees, with 0 degrees being left-to-right reading text. Higher values represent a counter-clockwise rotation. For example, a value of 90 would result in bottom-to-top reading text.",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "The coordinates given by x and y will define the basepoint of the first character (roughly the lower-left corner of the character). This is different from the imagestring(), where x and y define the upper-left corner of the first character. For example, \"top left\" is 0, 0.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "The y-ordinate. This sets the position of the fonts baseline, not the very bottom of the character.",
      ),
      array(
        'name'   => "col",
        'type'   => Int32,
        'desc'   => "The index of the desired color for the text, see imagecolorexact().",
      ),
      array(
        'name'   => "font_file",
        'type'   => String,
        'desc'   => "The path to the TrueType font you wish to use.\n\nDepending on which version of the GD library PHP is using, when fontfile does not begin with a leading / then .ttf will be appended to the filename and the library will attempt to search for that filename along a library-defined font path.\n\nWhen using versions of the GD library lower than 2.0.18, a space character, rather than a semicolon, was used as the 'path separator' for different font files. Unintentional use of this feature will result in the warning message: Warning: Could not find/open font. For these affected versions, the only solution is moving the font to a path which does not contain spaces.\n\nIn many cases where a font resides in the same directory as the script using it the following trick will alleviate any include problems.",
      ),
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "Text to be inserted into image.",
      ),
      array(
        'name'   => "extrainfo",
        'type'   => VariantMap,
        'value'  => "null",
        'desc'   => "Possible array indexes for extrainfo Key Type Meaning linespacing float Defines drawing linespacing",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagegammacorrect",
    'desc'   => "Applies gamma correction to the given gd image given an input and an output gamma.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "inputgamma",
        'type'   => Double,
        'desc'   => "The input gamma.",
      ),
      array(
        'name'   => "outputgamma",
        'type'   => Double,
        'desc'   => "The output gamma.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagegd2",
    'desc'   => "Outputs a GD2 image to the given filename.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path to save the file to. If not set or NULL, the raw image stream will be outputted directly.",
      ),
      array(
        'name'   => "chunk_size",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Chunk size.",
      ),
      array(
        'name'   => "type",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Either IMG_GD2_RAW or IMG_GD2_COMPRESSED. Default is IMG_GD2_RAW.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagegd",
    'desc'   => "Outputs a GD image to the given filename.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path to save the file to. If not set or NULL, the raw image stream will be outputted directly.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagegif",
    'desc'   => "imagegif() creates the GIF file in filename from the image image. The image argument is the return from the imagecreate() or imagecreatefrom* function.\n\nThe image format will be GIF87a unless the image has been made transparent with imagecolortransparent(), in which case the image format will be GIF89a.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path to save the file to. If not set or NULL, the raw image stream will be outputted directly.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagegrabscreen",
    'desc'   => "Grabs a screenshot of the whole screen.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on failure.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagegrabwindow",
    'desc'   => "Grabs a window or its client area using a windows handle (HWND property in COM instance)",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource identifier on success, FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "window",
        'type'   => Int32,
        'desc'   => "The HWND window ID.",
      ),
      array(
        'name'   => "client_area",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Include the client area of the application window.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageinterlace",
    'desc'   => "imageinterlace() turns the interlace bit on or off.\n\nIf the interlace bit is set and the image is used as a JPEG image, the image is created as a progressive JPEG.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns 1 if the interlace bit is set for the image, 0 otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "interlace",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "If non-zero, the image will be interlaced, else the interlace bit is turned off.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageistruecolor",
    'desc'   => "imageistruecolor() finds whether the image image is a truecolor image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the image is truecolor, FALSE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagejpeg",
    'desc'   => "imagejpeg() creates a JPEG file from the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path to save the file to. If not set or NULL, the raw image stream will be outputted directly.\n\nTo skip this argument in order to provide the quality parameter, use NULL.",
      ),
      array(
        'name'   => "quality",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "quality is optional, and ranges from 0 (worst quality, smaller file) to 100 (best quality, biggest file). The default is the default IJG quality value (about 75).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagelayereffect",
    'desc'   => "Set the alpha blending flag to use the bundled libgd layering effects.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "effect",
        'type'   => Int32,
        'desc'   => "One of the following constants: IMG_EFFECT_REPLACE Use pixel replacement (equivalent of passing TRUE to imagealphablending())",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageline",
    'desc'   => "Draws a line between the two given points.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x1",
        'type'   => Int32,
        'desc'   => "x-coordinate for first point.",
      ),
      array(
        'name'   => "y1",
        'type'   => Int32,
        'desc'   => "y-coordinate for first point.",
      ),
      array(
        'name'   => "x2",
        'type'   => Int32,
        'desc'   => "x-coordinate for second point.",
      ),
      array(
        'name'   => "y2",
        'type'   => Int32,
        'desc'   => "y-coordinate for second point.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The line color. A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imageloadfont",
    'desc'   => "imageloadfont() loads a user-defined bitmap and returns its identifier.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "The font identifier which is always bigger than 5 to avoid conflicts with built-in fonts or FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "file",
        'type'   => String,
        'desc'   => "The font file format is currently binary and architecture dependent. This means you should generate the font files on the same type of CPU as the machine you are running PHP on.\n\nFont file format byte position C data type description byte 0-3 int number of characters in the font byte 4-7 int value of first character in the font (often 32 for space) byte 8-11 int pixel width of each character byte 12-15 int pixel height of each character byte 16- char array with character data, one byte per pixel in each character, for a total of (nchars*width*height) bytes.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepalettecopy",
    'desc'   => "imagepalettecopy() copies the palette from the source image to the destination image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
      'desc'   => "No value is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "destination",
        'type'   => Resource,
        'desc'   => "The destination image resource.",
      ),
      array(
        'name'   => "source",
        'type'   => Resource,
        'desc'   => "The source image resource.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepng",
    'desc'   => "Outputs or saves a PNG image from the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path to save the file to. If not set or NULL, the raw image stream will be outputted directly.\n\nNULL is invalid if the quality and filters arguments are not used.",
      ),
      array(
        'name'   => "quality",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "Compression level: from 0 (no compression) to 9.",
      ),
      array(
        'name'   => "filters",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "Allows reducing the PNG file size. It is a bitmask field which may be set to any combination of the PNG_FILTER_XXX constants. PNG_NO_FILTER or PNG_ALL_FILTERS may also be used to respectively disable or activate all filters.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepolygon",
    'desc'   => "imagepolygon() creates a polygon in the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "points",
        'type'   => VariantVec,
        'desc'   => "An array containing the polygon's vertices, e.g.: points[0] = x0 points[1] = y0 points[2] = x1 points[3] = y1",
      ),
      array(
        'name'   => "num_points",
        'type'   => Int32,
        'desc'   => "Total number of points (vertices).",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepsbbox",
    'desc'   => "Gives the bounding box of a text rectangle using PostScript Type1 fonts.\n\nThe bounding box is calculated using information available from character metrics, and unfortunately tends to differ slightly from the results achieved by actually rasterizing the text. If the angle is 0 degrees, you can expect the text to need 1 pixel more to every direction.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64Vec,
      'desc'   => "Returns an array containing the following elements: 0 left x-coordinate 1 upper y-coordinate 2 right x-coordinate 3 lower y-coordinate",
    ),
    'args'   => array(
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "The text to be written.",
      ),
      array(
        'name'   => "font",
        'type'   => Int32,
        'desc'   => "A font resource, returned by imagepsloadfont().",
      ),
      array(
        'name'   => "size",
        'type'   => Int32,
        'desc'   => "size is expressed in pixels.",
      ),
      array(
        'name'   => "space",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Allows you to change the default value of a space in a font. This amount is added to the normal value and can also be negative. Expressed in character space units, where 1 unit is 1/1000th of an em-square.",
      ),
      array(
        'name'   => "tightness",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "tightness allows you to control the amount of white space between characters. This amount is added to the normal character width and can also be negative. Expressed in character space units, where 1 unit is 1/1000th of an em-square.",
      ),
      array(
        'name'   => "angle",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "angle is in degrees.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepsencodefont",
    'desc'   => "Loads a character encoding vector from a file and changes the fonts encoding vector to it. As a PostScript fonts default vector lacks most of the character positions above 127, you'll definitely want to change this if you use an other language than English.\n\nIf you find yourself using this function all the time, a much better way to define the encoding is to set ps.default_encoding in the configuration file to point to the right encoding file and all fonts you load will automatically have the right encoding.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "font_index",
        'type'   => Resource,
        'desc'   => "A font resource, returned by imagepsloadfont().",
      ),
      array(
        'name'   => "encodingfile",
        'type'   => String,
        'desc'   => "The exact format of this file is described in T1libs documentation. T1lib comes with two ready-to-use files, IsoLatin1.enc and IsoLatin2.enc.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepsextendfont",
    'desc'   => "Extend or condense a font (font_index), if the value of the extend parameter is less than one you will be condensing the font.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "font_index",
        'type'   => Int32,
        'desc'   => "A font resource, returned by imagepsloadfont().",
      ),
      array(
        'name'   => "extend",
        'type'   => Double,
        'desc'   => "Extension value, must be greater than 0.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepsfreefont",
    'desc'   => "imagepsfreefont() frees memory used by a PostScript Type 1 font.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "fontindex",
        'type'   => Resource,
        'desc'   => "A font resource, returned by imagepsloadfont().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepsloadfont",
    'desc'   => "Load a PostScript Type 1 font from the given filename.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Resource,
      'desc'   => "In the case everything went right, a valid font index will be returned and can be used for further purposes. Otherwise the function returns FALSE.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "Path to the Postscript font file.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepsslantfont",
    'desc'   => "Slant a given font given.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "font_index",
        'type'   => Resource,
        'desc'   => "A font resource, returned by imagepsloadfont().",
      ),
      array(
        'name'   => "slant",
        'type'   => Double,
        'desc'   => "Slant level.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagepstext",
    'desc'   => "Draws a text on an image using PostScript Type1 fonts.\n\nRefer to PostScript documentation about fonts and their measuring system if you have trouble understanding how this works.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
      'desc'   => "This function returns an array containing the following elements: 0 lower left x-coordinate 1 lower left y-coordinate 2 upper right x-coordinate 3 upper right y-coordinate",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "The text to be written.",
      ),
      array(
        'name'   => "font",
        'type'   => Resource,
        'desc'   => "A font resource, returned by imagepsloadfont().",
      ),
      array(
        'name'   => "size",
        'type'   => Int32,
        'desc'   => "size is expressed in pixels.",
      ),
      array(
        'name'   => "foreground",
        'type'   => Int32,
        'desc'   => "The color in which the text will be painted.",
      ),
      array(
        'name'   => "background",
        'type'   => Int32,
        'desc'   => "The color to which the text will try to fade in with antialiasing. No pixels with the color background are actually painted, so the background image does not need to be of solid color.",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate for the lower-left corner of the first character.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate for the lower-left corner of the first character.",
      ),
      array(
        'name'   => "space",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Allows you to change the default value of a space in a font. This amount is added to the normal value and can also be negative. Expressed in character space units, where 1 unit is 1/1000th of an em-square.",
      ),
      array(
        'name'   => "tightness",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "tightness allows you to control the amount of white space between characters. This amount is added to the normal character width and can also be negative. Expressed in character space units, where 1 unit is 1/1000th of an em-square.",
      ),
      array(
        'name'   => "angle",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "angle is in degrees.",
      ),
      array(
        'name'   => "antialias_steps",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Allows you to control the number of colours used for antialiasing text. Allowed values are 4 and 16. The higher value is recommended for text sizes lower than 20, where the effect in text quality is quite visible. With bigger sizes, use 4. It's less computationally intensive.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagerectangle",
    'desc'   => "imagerectangle() creates a rectangle starting at the specified coordinates.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x1",
        'type'   => Int32,
        'desc'   => "Upper left x coordinate.",
      ),
      array(
        'name'   => "y1",
        'type'   => Int32,
        'desc'   => "Upper left y coordinate 0, 0 is the top left corner of the image.",
      ),
      array(
        'name'   => "x2",
        'type'   => Int32,
        'desc'   => "Bottom right x coordinate.",
      ),
      array(
        'name'   => "y2",
        'type'   => Int32,
        'desc'   => "Bottom right y coordinate.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagerotate",
    'desc'   => "Rotates the image image using the given angle in degrees.\n\nThe center of rotation is the center of the image, and the rotated image may have different dimensions than the original image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an image resource for the rotated image, or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "source_image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "angle",
        'type'   => Double,
        'desc'   => "Rotation angle, in degrees.",
      ),
      array(
        'name'   => "bgd_color",
        'type'   => Int32,
        'desc'   => "Specifies the color of the uncovered zone after the rotation",
      ),
      array(
        'name'   => "ignore_transparent",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "If set and non-zero, transparent colors are ignored (otherwise kept).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesavealpha",
    'desc'   => "imagesavealpha() sets the flag to attempt to save full alpha channel information (as opposed to single-color transparency) when saving PNG images.\n\nYou have to unset alphablending (imagealphablending(\$im, false)), to use it.\n\nAlpha channel is not supported by all browsers, if you have problem with your browser, try to load your script with an alpha channel compliant browser, e.g. latest Mozilla.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "saveflag",
        'type'   => Boolean,
        'desc'   => "Whether to save the alpha channel or not. Default to FALSE.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesetbrush",
    'desc'   => "imagesetbrush() sets the brush image to be used by all line drawing functions (such as imageline() and imagepolygon()) when drawing with the special colors IMG_COLOR_BRUSHED or IMG_COLOR_STYLEDBRUSHED.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "brush",
        'type'   => Resource,
        'desc'   => "An image resource.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesetpixel",
    'desc'   => "imagesetpixel() draws a pixel at the specified coordinate.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesetstyle",
    'desc'   => "imagesetstyle() sets the style to be used by all line drawing functions (such as imageline() and imagepolygon()) when drawing with the special color IMG_COLOR_STYLED or lines of images with color IMG_COLOR_STYLEDBRUSHED.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "style",
        'type'   => VariantMap,
        'desc'   => "An array of pixel colors. You can use the IMG_COLOR_TRANSPARENT constant to add a transparent pixel.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesetthickness",
    'desc'   => "imagesetthickness() sets the thickness of the lines drawn when drawing rectangles, polygons, ellipses etc. etc. to thickness pixels.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "thickness",
        'type'   => Int32,
        'desc'   => "Thickness, in pixels.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesettile",
    'desc'   => "imagesettile() sets the tile image to be used by all region filling functions (such as imagefill() and imagefilledpolygon()) when filling with the special color IMG_COLOR_TILED.\n\nA tile is an image used to fill an area with a repeated pattern. Any GD image can be used as a tile, and by setting the transparent color index of the tile image with imagecolortransparent(), a tile allows certain parts of the underlying area to shine through can be created.\n\nYou need not take special action when you are finished with a tile, but if you destroy the tile image, you must not use the IMG_COLOR_TILED color until you have set a new tile image!",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "tile",
        'type'   => Resource,
        'desc'   => "The image resource to be used as a tile.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagestring",
    'desc'   => "Draws a string at the given coordinates.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "font",
        'type'   => Int32,
        'desc'   => "Can be 1, 2, 3, 4, 5 for built-in fonts in latin2 encoding (where higher numbers corresponding to larger fonts) or any of your own font identifiers registered with imageloadfont().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate of the upper left corner.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate of the upper left corner.",
      ),
      array(
        'name'   => "str",
        'type'   => String,
        'desc'   => "The string to be written.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagestringup",
    'desc'   => "Draws a string vertically at the given coordinates.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "font",
        'type'   => Int32,
        'desc'   => "Can be 1, 2, 3, 4, 5 for built-in fonts in latin2 encoding (where higher numbers corresponding to larger fonts) or any of your own font identifiers registered with imageloadfont().",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "x-coordinate of the bottom left corner.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "y-coordinate of the bottom left corner.",
      ),
      array(
        'name'   => "str",
        'type'   => String,
        'desc'   => "The string to be written.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "A color identifier created with imagecolorallocate().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesx",
    'desc'   => "Returns the width of the given image resource.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Return the width of the image or FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagesy",
    'desc'   => "Returns the height of the given image resource.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Return the height of the image or FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagetruecolortopalette",
    'desc'   => "imagetruecolortopalette() converts a truecolor image to a palette image. The code for this function was originally drawn from the Independent JPEG Group library code, which is excellent. The code has been modified to preserve as much alpha channel information as possible in the resulting palette, in addition to preserving colors as well as possible. This does not work as well as might be hoped. It is usually best to simply produce a truecolor output image instead, which guarantees the highest output quality.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "dither",
        'type'   => Boolean,
        'desc'   => "Indicates if the image should be dithered - if it is TRUE then dithering will be used which will result in a more speckled image but with better color approximation.",
      ),
      array(
        'name'   => "ncolors",
        'type'   => Int32,
        'desc'   => "Sets the maximum number of colors that should be retained in the palette.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagettfbbox",
    'desc'   => "This function calculates and returns the bounding box in pixels for a TrueType text.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "imagettfbbox() returns an array with 8 elements representing four points making the bounding box of the text on success and FALSE on error. key contents 0 lower left corner, X position 1 lower left corner, Y position 2 lower right corner, X position 3 lower right corner, Y position 4 upper right corner, X position 5 upper right corner, Y position 6 upper left corner, X position 7 upper left corner, Y position\n\nThe points are relative to the text regardless of the angle, so \"upper left\" means in the top left-hand corner seeing the text horizontally.",
    ),
    'args'   => array(
      array(
        'name'   => "size",
        'type'   => Double,
        'desc'   => "The font size. Depending on your version of GD, this should be specified as the pixel size (GD1) or point size (GD2).",
      ),
      array(
        'name'   => "angle",
        'type'   => Double,
        'desc'   => "Angle in degrees in which text will be measured.",
      ),
      array(
        'name'   => "fontfile",
        'type'   => String,
        'desc'   => "The name of the TrueType font file (can be a URL). Depending on which version of the GD library that PHP is using, it may attempt to search for files that do not begin with a leading '/' by appending '.ttf' to the filename and searching along a library-defined font path.",
      ),
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "The string to be measured.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagettftext",
    'desc'   => "Writes the given text into the image using TrueType fonts.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array with 8 elements representing four points making the bounding box of the text. The order of the points is lower left, lower right, upper right, upper left. The points are relative to the text regardless of the angle, so \"upper left\" means in the top left-hand corner when you see the text horizontally. Returns FALSE on error.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "size",
        'type'   => Double,
        'desc'   => "The font size. Depending on your version of GD, this should be specified as the pixel size (GD1) or point size (GD2).",
      ),
      array(
        'name'   => "angle",
        'type'   => Double,
        'desc'   => "The angle in degrees, with 0 degrees being left-to-right reading text. Higher values represent a counter-clockwise rotation. For example, a value of 90 would result in bottom-to-top reading text.",
      ),
      array(
        'name'   => "x",
        'type'   => Int32,
        'desc'   => "The coordinates given by x and y will define the basepoint of the first character (roughly the lower-left corner of the character). This is different from the imagestring(), where x and y define the upper-left corner of the first character. For example, \"top left\" is 0, 0.",
      ),
      array(
        'name'   => "y",
        'type'   => Int32,
        'desc'   => "The y-ordinate. This sets the position of the fonts baseline, not the very bottom of the character.",
      ),
      array(
        'name'   => "color",
        'type'   => Int32,
        'desc'   => "The color index. Using the negative of a color index has the effect of turning off antialiasing. See imagecolorallocate().",
      ),
      array(
        'name'   => "fontfile",
        'type'   => String,
        'desc'   => "The path to the TrueType font you wish to use.\n\nDepending on which version of the GD library PHP is using, when fontfile does not begin with a leading / then .ttf will be appended to the filename and the library will attempt to search for that filename along a library-defined font path.\n\nWhen using versions of the GD library lower than 2.0.18, a space character, rather than a semicolon, was used as the 'path separator' for different font files. Unintentional use of this feature will result in the warning message: Warning: Could not find/open font. For these affected versions, the only solution is moving the font to a path which does not contain spaces.\n\nIn many cases where a font resides in the same directory as the script using it the following trick will alleviate any include problems.",
      ),
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "The text string in UTF-8 encoding.\n\nMay include decimal numeric character references (of the form: &#8364;) to access characters in a font beyond position 127. The hexadecimal format (like &#xA9;) is supported. Strings in UTF-8 encoding can be passed directly.\n\nNamed entities, such as &copy;, are not supported. Consider using html_entity_decode() to decode these named entities into UTF-8 strings (html_entity_decode() supports this as of PHP 5.0.0).\n\nIf a character is used in the string which is not supported by the font, a hollow rectangle will replace the character.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagetypes",
    'desc'   => "Returns the image types supported by the current PHP installation.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns a bit-field corresponding to the image formats supported by the version of GD linked into PHP. The following bits are returned, IMG_GIF | IMG_JPG | IMG_PNG | IMG_WBMP | IMG_XPM.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagewbmp",
    'desc'   => "imagewbmp() outputs or save a WBMP version of the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path to save the file to. If not set or NULL, the raw image stream will be outputted directly.",
      ),
      array(
        'name'   => "foreground",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "You can set the foreground color with this parameter by setting an identifier obtained from imagecolorallocate(). The default foreground color is black.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imagexbm",
    'desc'   => "Outputs or save an XBM version of the given image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "image",
        'type'   => Resource,
        'desc'   => "An image resource, returned by one of the image creation functions, such as imagecreatetruecolor().",
      ),
      array(
        'name'   => "filename",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path to save the file to. If not set or NULL, the raw image stream will be outputted directly.",
      ),
      array(
        'name'   => "foreground",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "You can set the foreground color with this parameter by setting an identifier obtained from imagecolorallocate(). The default foreground color is black.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "iptcembed",
    'desc'   => "Embeds binary IPTC data into a JPEG image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "If success and spool flag is lower than 2 then the JPEG will not be returned as a string, FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "iptcdata",
        'type'   => String,
        'desc'   => "The data to be written.",
      ),
      array(
        'name'   => "jpeg_file_name",
        'type'   => String,
        'desc'   => "Path to the JPEG image.",
      ),
      array(
        'name'   => "spool",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Spool flag. If the spool flag is over 2 then the JPEG will be returned as a string.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "iptcparse",
    'desc'   => "Parses an  IPTC block into its single tags.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array using the tagmarker as an index and the value as the value. It returns FALSE on error or if no IPTC data was found.",
    ),
    'args'   => array(
      array(
        'name'   => "iptcblock",
        'type'   => String,
        'desc'   => "A binary IPTC block.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "jpeg2wbmp",
    'desc'   => "Converts a JPEG file into a WBMP file.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "jpegname",
        'type'   => String,
        'desc'   => "Path to JPEG file.",
      ),
      array(
        'name'   => "wbmpname",
        'type'   => String,
        'desc'   => "Path to destination WBMP file.",
      ),
      array(
        'name'   => "dest_height",
        'type'   => Int32,
        'desc'   => "Destination image height.",
      ),
      array(
        'name'   => "dest_width",
        'type'   => Int32,
        'desc'   => "Destination image width.",
      ),
      array(
        'name'   => "threshold",
        'type'   => Int32,
        'desc'   => "Threshold value, between 0 and 8 (inclusive).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "png2wbmp",
    'desc'   => "Converts a PNG file into a WBMP file.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "pngname",
        'type'   => String,
        'desc'   => "Path to PNG file.",
      ),
      array(
        'name'   => "wbmpname",
        'type'   => String,
        'desc'   => "Path to destination WBMP file.",
      ),
      array(
        'name'   => "dest_height",
        'type'   => Int32,
        'desc'   => "Destination image height.",
      ),
      array(
        'name'   => "dest_width",
        'type'   => Int32,
        'desc'   => "Destination image width.",
      ),
      array(
        'name'   => "threshold",
        'type'   => Int32,
        'desc'   => "Threshold value, between 0 and 8 (inclusive).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "exif_imagetype",
    'desc'   => "exif_imagetype() reads the first bytes of an image and checks its signature.\n\nexif_imagetype() can be used to avoid calls to other exif functions with unsupported file types or in conjunction with \$_SERVER['HTTP_ACCEPT'] to check whether or not the viewer is able to see a specific image in the browser.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "When a correct signature is found, the appropriate constant value will be returned otherwise the return value is FALSE. The return value is the same value that getimagesize() returns in index 2 but exif_imagetype() is much faster.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "The image being checked.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "exif_read_data",
    'desc'   => "exif_read_data() reads the EXIF headers from a JPEG or TIFF image file. This way you can read meta data generated by digital cameras.\n\nEXIF headers tend to be present in JPEG/TIFF images generated by digital cameras, but unfortunately each digital camera maker has a different idea of how to actually tag their images, so you can't always rely on a specific Exif header being present.\n\nHeight and Width are computed the same way getimagesize() does so their values must not be part of any header returned. Also, html is a height/width text string to be used inside normal HTML.\n\nWhen an Exif header contains a Copyright note, this itself can contain two values. As the solution is inconsistent in the Exif 2.10 standard, the COMPUTED section will return both entries Copyright.Photographer and Copyright.Editor while the IFD0 sections contains the byte array with the NULL character that splits both entries. Or just the first entry if the datatype was wrong (normal behaviour of Exif). The COMPUTED will also contain the entry Copyright which is either the original copyright string, or a comma separated list of the photo and editor copyright.\n\nThe tag UserComment has the same problem as the Copyright tag. It can store two values. First the encoding used, and second the value itself. If so the IFD section only contains the encoding or a byte array. The COMPUTED section will store both in the entries UserCommentEncoding and UserComment. The entry UserComment is available in both cases so it should be used in preference to the value in IFD0 section.\n\nexif_read_data() also validates EXIF data tags according to the EXIF specification ( http://exif.org/Exif2-2.PDF, page 20).\n\nWindows ME/XP can both wipe the Exif headers when connecting to a camera. More information available at  http://www.canon.co.jp/Imaging/NOTICE/011214-e.html.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "It returns an associative array where the array indexes are the header names and the array values are the values associated with those headers. If no data can be returned, exif_read_data() will return FALSE.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "The name of the image file being read. This cannot be an URL.",
      ),
      array(
        'name'   => "sections",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "Is a comma separated list of sections that need to be present in file to produce a result array. If none of the requested sections could be found the return value is FALSE. FILE FileName, FileSize, FileDateTime, SectionsFound COMPUTED html, Width, Height, IsColor, and more if available. Height and Width are computed the same way getimagesize() does so their values must not be part of any header returned. Also, html is a height/width text string to be used inside normal HTML. ANY_TAG Any information that has a Tag e.g. IFD0, EXIF, ... IFD0 All tagged data of IFD0. In normal imagefiles this contains image size and so forth. THUMBNAIL A file is supposed to contain a thumbnail if it has a second IFD. All tagged information about the embedded thumbnail is stored in this section. COMMENT Comment headers of JPEG images. EXIF The EXIF section is a sub section of IFD0. It contains more detailed information about an image. Most of these entries are digital camera related.",
      ),
      array(
        'name'   => "arrays",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "Specifies whether or not each section becomes an array. The sections COMPUTED, THUMBNAIL, and COMMENT always become arrays as they may contain values whose names conflict with other sections.",
      ),
      array(
        'name'   => "thumbnail",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "When set to TRUE the thumbnail itself is read. Otherwise, only the tagged data is read.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "read_exif_data",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
      ),
      array(
        'name'   => "sections",
        'type'   => String,
        'value'  => "null_string",
      ),
      array(
        'name'   => "arrays",
        'type'   => Boolean,
        'value'  => "false",
      ),
      array(
        'name'   => "thumbnail",
        'type'   => Boolean,
        'value'  => "false",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "exif_tagname",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the header name, or FALSE if index is undefined.",
    ),
    'args'   => array(
      array(
        'name'   => "index",
        'type'   => Int32,
        'desc'   => "The image index",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "exif_thumbnail",
    'desc'   => "exif_thumbnail() reads the embedded thumbnail of a TIFF or JPEG image.\n\nIf you want to deliver thumbnails through this function, you should send the mimetype information using the header() function.\n\nIt is possible that exif_thumbnail() cannot create an image but can determine its size. In this case, the return value is FALSE but width and height are set.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the embedded thumbnail, or FALSE if the image contains no thumbnail.",
    ),
    'args'   => array(
      array(
        'name'   => "filename",
        'type'   => String,
        'desc'   => "The name of the image file being read. This image contains an embedded thumbnail.",
      ),
      array(
        'name'   => "width",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "The return width of the returned thumbnail.",
      ),
      array(
        'name'   => "height",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "The returned height of the returned thumbnail.",
      ),
      array(
        'name'   => "imagetype",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "The returned image type of the returned thumbnail. This is either TIFF or JPEG.",
      ),
    ),
  ));


///////////////////////////////////////////////////////////////////////////////
// Classes
//
// BeginClass
// array (
//   'name'   => name of the class
//   'desc'   => description of the class's purpose
//   'flags'  => attributes of the class, see base.php for possible values
//   'note'   => additional note about this class's schema
//   'parent' => parent class name, if any
//   'ifaces' => array of interfaces tihs class implements
//   'bases'  => extra internal and special base classes this class requires
//   'footer' => extra C++ inserted at end of class declaration
// )
//
// DefineConstant(..)
// DefineConstant(..)
// ...
// DefineFunction(..)
// DefineFunction(..)
// ...
// DefineProperty
// DefineProperty
//
// array (
//   'name'  => name of the property
//   'type'  => type of the property
//   'flags' => attributes of the property
//   'desc'  => description of the property
//   'note'  => additional note about this property's schema
// )
//
// EndClass()

