<?php
/**
 * Automatically generated by running "php schema.php imap".
 *
 * You may modify the file, but re-running schema.php against this file will
 * standardize the format without losing your schema changes. It does lose
 * any changes that are not part of schema. Use "note" field to comment on
 * schema itself, and "note" fields are not used in any code generation but
 * only staying within this file.
 *
 * @nolint
 */
///////////////////////////////////////////////////////////////////////////////
// Preamble: C++ code inserted at beginning of ext_{name}.h

DefinePreamble(<<<CPP

CPP
);

///////////////////////////////////////////////////////////////////////////////
// Constants
//
// array (
//   'name' => name of the constant
//   'type' => type of the constant
//   'note' => additional note about this constant's schema
// )


///////////////////////////////////////////////////////////////////////////////
// Functions
//
// array (
//   'name'   => name of the function
//   'desc'   => description of the function's purpose
//   'flags'  => attributes of the function, see base.php for possible values
//   'opt'    => optimization callback function's name for compiler
//   'note'   => additional note about this function's schema
//   'return' =>
//      array (
//        'type'  => return type, use Reference for ref return
//        'desc'  => description of the return value
//      )
//   'args'   => arguments
//      array (
//        'name'  => name of the argument
//        'type'  => type of the argument, use Reference for output parameter
//        'value' => default value of the argument
//        'desc'  => description of the argument
//      )
// )

DefineFunction(
  array(
    'name'   => "imap_8bit",
    'desc'   => "Convert an 8bit string to a quoted-printable string (according to  RFC2045, section 6.7).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a quoted-printable string.",
    ),
    'args'   => array(
      array(
        'name'   => "str",
        'type'   => String,
        'desc'   => "The 8bit string to convert",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_alerts",
    'desc'   => "Returns all of the IMAP alert messages generated since the last imap_alerts() call, or the beginning of the page.\n\nWhen imap_alerts() is called, the alert stack is subsequently cleared. The IMAP specification requires that these messages be passed to the user.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of all of the IMAP alert messages generated or FALSE if no alert messages are available.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_append",
    'desc'   => "Appends a string message to the specified mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "message",
        'type'   => String,
        'desc'   => "The message to be append, as a string\n\nWhen talking to the Cyrus IMAP server, you must use \"\\r\\n\" as your end-of-line terminator instead of \"\\n\" or the operation will fail",
      ),
      array(
        'name'   => "options",
        'type'   => String,
        'value'  => "\"\"",
        'desc'   => "If provided, the options will also be written to the mailbox",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_base64",
    'desc'   => "Decodes the given BASE-64 encoded text.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the decoded message as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "The encoded text",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_binary",
    'desc'   => "Convert an 8bit string to a base64 string according to  RFC2045, Section 6.8.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a base64 encoded string.",
    ),
    'args'   => array(
      array(
        'name'   => "str",
        'type'   => String,
        'desc'   => "The 8bit string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_body",
    'desc'   => "imap_body() returns the body of the message, numbered msg_number in the current mailbox.\n\nimap_body() will only return a verbatim copy of the message body. To extract single parts of a multipart MIME-encoded message you have to use imap_fetchstructure() to analyze its structure and imap_fetchbody() to extract a copy of a single body component.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the body of the specified message, as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "The optional options are a bit mask with one or more of the following: FT_UID - The msg_number is a UID FT_PEEK - Do not set the \\Seen flag if not already set FT_INTERNAL - The return string is in internal format, will not canonicalize to CRLF.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_bodystruct",
    'desc'   => "Read the structure of a specified body section of a specific message.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the information in an object, for a detailed description of the object structure and properties see imap_fetchstructure().",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "section",
        'type'   => String,
        'desc'   => "The body section to read",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_check",
    'desc'   => "Checks information about the current mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the information in an object with following properties: Date - current system time formatted according to  RFC2822 Driver - protocol used to access this mailbox: POP3, IMAP, NNTP Mailbox - the mailbox name Nmsgs - number of messages in the mailbox Recent - number of recent messages in the mailbox\n\nReturns FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_clearflag_full",
    'desc'   => "This function causes a store to delete the specified flag to the flags set for the messages in the specified sequence.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "sequence",
        'type'   => String,
        'desc'   => "A sequence of message numbers. You can enumerate desired messages with the X,Y syntax, or retrieve all messages within an interval with the X:Y syntax",
      ),
      array(
        'name'   => "flag",
        'type'   => String,
        'desc'   => "The flags which you can unset are \"\\\\Seen\", \"\\\\Answered\", \"\\\\Flagged\", \"\\\\Deleted\", and \"\\\\Draft\" (as defined by  RFC2060)",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "options are a bit mask and may contain the single option: ST_UID - The sequence argument contains UIDs instead of sequence numbers",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_close",
    'desc'   => "Closes the imap stream.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "flag",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "If set to CL_EXPUNGE, the function will silently expunge the mailbox before closing, removing all messages marked for deletion. You can achieve the same thing by using imap_expunge()",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_createmailbox",
    'desc'   => "Creates a new mailbox specified by mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information. Names containing international characters should be encoded by imap_utf7_encode()",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_delete",
    'desc'   => "Marks messages listed in msg_number for deletion. Messages marked for deletion will stay in the mailbox until either imap_expunge() is called or imap_close() is called with the optional parameter CL_EXPUNGE.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => String,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "You can set the FT_UID which tells the function to treat the msg_number argument as an UID.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_deletemailbox",
    'desc'   => "Deletes the specified mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_errors",
    'desc'   => "Gets all of the IMAP errors (if any) that have occurred during this page request or since the error stack was reset.\n\nWhen imap_errors() is called, the error stack is subsequently cleared.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "This function returns an array of all of the IMAP error messages generated since the last imap_errors() call, or the beginning of the page. Returns FALSE if no error messages are available.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_expunge",
    'desc'   => "Deletes all the messages marked for deletion by imap_delete(), imap_mail_move(), or imap_setflag_full().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_fetch_overview",
    'desc'   => "This function fetches mail headers for the given sequence and returns an overview of their contents.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of objects describing one message header each. The object will only define a property if it exists. The possible properties are: subject - the messages subject from - who sent it to - recipient date - when was it sent message_id - Message-ID references - is a reference to this message id in_reply_to - is a reply to this message id size - size in bytes uid - UID the message has in the mailbox msgno - message sequence number in the mailbox recent - this message is flagged as recent flagged - this message is flagged answered - this message is flagged as answered deleted - this message is flagged for deletion seen - this message is flagged as already read draft - this message is flagged as being a draft",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "sequence",
        'type'   => String,
        'desc'   => "A message sequence description. You can enumerate desired messages with the X,Y syntax, or retrieve all messages within an interval with the X:Y syntax",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "sequence will contain a sequence of message indices or UIDs, if this parameter is set to FT_UID.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_fetchbody",
    'desc'   => "Fetch of a particular section of the body of the specified messages. Body parts are not decoded by this function.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a particular section of the body of the specified messages as a text string.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "section",
        'type'   => String,
        'desc'   => "The part number. It is a string of integers delimited by period which index into a body part list as per the IMAP4 specification",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "A bitmask with one or more of the following: FT_UID - The msg_number is a UID FT_PEEK - Do not set the \\Seen flag if not already set FT_INTERNAL - The return string is in internal format, will not canonicalize to CRLF.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_fetchheader",
    'desc'   => "This function causes a fetch of the complete, unfiltered  RFC2822 format header of the specified message.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the header of the specified message as a text string.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "The possible options are: FT_UID - The msgno argument is a UID FT_INTERNAL - The return string is in \"internal\" format, without any attempt to canonicalize to CRLF newlines FT_PREFETCHTEXT - The RFC822.TEXT should be pre-fetched at the same time. This avoids an extra RTT on an IMAP connection if a full message text is desired (e.g. in a \"save to local file\" operation)",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_fetchstructure",
    'desc'   => "Fetches all the structured information for a given message.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "This optional parameter only has a single option, FT_UID, which tells the function to treat the msg_number argument as a UID.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_gc",
    'desc'   => "Purges the cache of entries of a specific type.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "caches",
        'type'   => Int64,
        'desc'   => "Specifies the cache to purge. It may one or a combination of the following constants: IMAP_GC_ELT (message cache elements), IMAP_GC_ENV (enveloppe and bodies), IMAP_GC_TEXTS (texts).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_get_quota",
    'desc'   => "Retrieve the quota level settings, and usage statics per mailbox.\n\nFor a non-admin user version of this function, please see the imap_get_quotaroot() function of PHP.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array with integer values limit and usage for the given mailbox. The value of limit represents the total amount of space allowed for this mailbox. The usage value represents the mailboxes current level of capacity. Will return FALSE in the case of failure.\n\nAs of PHP 4.3, the function more properly reflects the functionality as dictated by the  RFC2087. The array return value has changed to support an unlimited number of returned resources (i.e. messages, or sub-folders) with each named resource receiving an individual array key. Each key value then contains an another array with the usage and limit values within it.\n\nFor backwards compatibility reasons, the original access methods are still available for use, although it is suggested to update.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "quota_root",
        'type'   => String,
        'desc'   => "quota_root should normally be in the form of user.name where name is the mailbox you wish to retrieve information about.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_get_quotaroot",
    'desc'   => "Retrieve the quota settings per user. The limit value represents the total amount of space allowed for this user's total mailbox usage. The usage value represents the user's current total mailbox capacity.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of integer values pertaining to the specified user mailbox. All values contain a key based upon the resource name, and a corresponding array with the usage and limit values within.\n\nThis function will return FALSE in the case of call failure, and an array of information about the connection upon an un-parsable response from the server.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "quota_root",
        'type'   => String,
        'desc'   => "quota_root should normally be in the form of which mailbox (i.e. INBOX).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_getacl",
    'desc'   => "Gets the ACL for a given mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an associative array of \"folder\" => \"acl\" pairs.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_getmailboxes",
    'desc'   => "Gets information on the mailboxes.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of objects containing mailbox information. Each object has the attributes name, specifying the full name of the mailbox; delimiter, which is the hierarchy delimiter for the part of the hierarchy this mailbox is in; and attributes. Attributes is a bitmask that can be tested against:\n\nLATT_NOINFERIORS - This mailbox contains, and may not contain any \"children\" (there are no mailboxes below this one). Calling imap_createmailbox() will not work on this mailbox.\n\nLATT_NOSELECT - This is only a container, not a mailbox - you cannot open it.\n\nLATT_MARKED - This mailbox is marked. This means that it may contain new messages since the last time it was checked. Not provided by all IMAP servers.\n\nLATT_UNMARKED - This mailbox is not marked, does not contain new messages. If either MARKED or UNMARKED is provided, you can assume the IMAP server supports this feature for this mailbox.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open()",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_getsubscribed",
    'desc'   => "Gets information about the subscribed mailboxes.\n\nIdentical to imap_getmailboxes(), except that it only returns mailboxes that the user is subscribed to.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of objects containing mailbox information. Each object has the attributes name, specifying the full name of the mailbox; delimiter, which is the hierarchy delimiter for the part of the hierarchy this mailbox is in; and attributes. Attributes is a bitmask that can be tested against: LATT_NOINFERIORS - This mailbox has no \"children\" (there are no mailboxes below this one). LATT_NOSELECT - This is only a container, not a mailbox - you cannot open it. LATT_MARKED - This mailbox is marked. Only used by UW-IMAPD. LATT_UNMARKED - This mailbox is not marked. Only used by UW-IMAPD.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open()",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_header",
    'desc'   => "Gets information about the given message number by reading its headers.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "fromlength",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Number of characters for the fetchfrom property. Must be greater than or equal to zero.",
      ),
      array(
        'name'   => "subjectlength",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Number of characters for the fetchsubject property Must be greater than or equal to zero.",
      ),
      array(
        'name'   => "defaulthost",
        'type'   => String,
        'value'  => "\"\"",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_headerinfo",
    'desc'   => "Gets information about the given message number by reading its headers.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "fromlength",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Number of characters for the fetchfrom property. Must be greater than or equal to zero.",
      ),
      array(
        'name'   => "subjectlength",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Number of characters for the fetchsubject property Must be greater than or equal to zero.",
      ),
      array(
        'name'   => "defaulthost",
        'type'   => String,
        'value'  => "\"\"",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_headers",
    'desc'   => "Returns headers for all messages in a mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of string formatted with header info. One element per mail message.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_last_error",
    'desc'   => "Gets the full text of the last IMAP error message that occurred on the current page. The error stack is untouched; calling imap_last_error() subsequently, with no intervening errors, will return the same error.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the full text of the last IMAP error message that occurred on the current page. Returns FALSE if no error messages are available.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_list",
    'desc'   => "Read the list of mailboxes.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array containing the names of the mailboxes.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open().",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_listmailbox",
    'desc'   => "Read the list of mailboxes.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array containing the names of the mailboxes.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open().",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_listscan",
    'desc'   => "Returns an array containing the names of the mailboxes that have content in the text of the mailbox.\n\nThis function is similar to imap_listmailbox(), but it will additionally check for the presence of the string content inside the mailbox data.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array containing the names of the mailboxes that have content in the text of the mailbox.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open()",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
      array(
        'name'   => "content",
        'type'   => String,
        'desc'   => "The searched string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_listsubscribed",
    'desc'   => "Gets an array of all the mailboxes that you have subscribed.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of all the subscribed mailboxes.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open()",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_lsub",
    'desc'   => "Gets an array of all the mailboxes that you have subscribed.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of all the subscribed mailboxes.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open()",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_mail_compose",
    'desc'   => "Create a MIME message based on the given envelope and body sections.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the MIME message.",
    ),
    'args'   => array(
      array(
        'name'   => "envelope",
        'type'   => VariantMap,
        'desc'   => "An associative array of headers fields. Valid keys are: \"remail\", \"return_path\", \"date\", \"from\", \"reply_to\", \"in_reply_to\", \"subject\", \"to\", \"cc\", \"bcc\", \"message_id\" and \"custom_headers\" (which contains associative array of other headers).",
      ),
      array(
        'name'   => "body",
        'type'   => VariantMap,
        'desc'   => "An indexed array of bodies\n\nA body is an associative array which can consist of the following keys: \"type\", \"encoding\", \"charset\", \"type.parameters\", \"subtype\", \"id\", \"description\", \"disposition.type\", \"disposition\", \"contents.data\", \"lines\", \"bytes\" and \"md5\".",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_mail_copy",
    'desc'   => "Copies mail messages specified by msglist to specified mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msglist",
        'type'   => String,
        'desc'   => "msglist is a range not just message numbers (as described in  RFC2060).",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "options is a bitmask of one or more of CP_UID - the sequence numbers contain UIDS CP_MOVE - Delete the messages from the current mailbox after copying",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_mail_move",
    'desc'   => "Moves mail messages specified by msglist to the specified mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msglist",
        'type'   => String,
        'desc'   => "msglist is a range not just message numbers (as described in  RFC2060).",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "options is a bitmask and may contain the single option: CP_UID - the sequence numbers contain UIDS",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_mail",
    'desc'   => "This function allows sending of emails with correct handling of Cc and Bcc receivers.\n\nThe parameters to, cc and bcc are all strings and are all parsed as  RFC822 address lists.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "to",
        'type'   => String,
        'desc'   => "The receiver",
      ),
      array(
        'name'   => "subject",
        'type'   => String,
        'desc'   => "The mail subject",
      ),
      array(
        'name'   => "message",
        'type'   => String,
        'desc'   => "The mail body",
      ),
      array(
        'name'   => "additional_headers",
        'type'   => String,
        'value'  => "\"\"",
        'desc'   => "As string with additional headers to be set on the mail",
      ),
      array(
        'name'   => "cc",
        'type'   => String,
        'value'  => "\"\"",
      ),
      array(
        'name'   => "bcc",
        'type'   => String,
        'value'  => "\"\"",
        'desc'   => "The receivers specified in bcc will get the mail, but are excluded from the headers.",
      ),
      array(
        'name'   => "rpath",
        'type'   => String,
        'value'  => "\"\"",
        'desc'   => "Use this parameter to specify return path upon mail delivery failure. This is useful when using PHP as a mail client for multiple users.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_mailboxmsginfo",
    'desc'   => "Checks the current mailbox status on the server. It is similar to imap_status(), but will additionally sum up the size of all messages in the mailbox, which will take some additional time to execute.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the information in an object with following properties: Mailbox properties Date date of last change (current datetime) Driver driver Mailbox name of the mailbox Nmsgs number of messages Recent number of recent messages Unread number of unread messages Deleted number of deleted messages Size mailbox size\n\nReturns FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_mime_header_decode",
    'desc'   => "Decodes MIME message header extensions that are non ASCII text (see  RFC2047).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "The decoded elements are returned in an array of objects, where each object has two properties, charset and text.\n\nIf the element hasn't been encoded, and in other words is in plain US-ASCII, the charset property of that element is set to default.",
    ),
    'args'   => array(
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "The MIME text",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_msgno",
    'desc'   => "Returns the message sequence number for the given uid.\n\nThis function is the inverse of imap_uid().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the message sequence number for the given uid.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "uid",
        'type'   => Int64,
        'desc'   => "The message UID",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_num_msg",
    'desc'   => "Gets the number of messages in the current mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Return the number of messages in the current mailbox, as an integer.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_num_recent",
    'desc'   => "Gets the number of recent messages in the current mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the number of recent messages in the current mailbox, as an integer.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_open",
    'desc'   => "Opens an IMAP stream to a mailbox.\n\nThis function can also be used to open streams to POP3 and NNTP servers, but some functions and features are only available on IMAP servers.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an IMAP stream on success or FALSE on error.",
    ),
    'args'   => array(
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "A mailbox name consists of a server and a mailbox path on this server. The special name INBOX stands for the current users personal mailbox. Mailbox names that contain international characters besides those in the printable ASCII space have to be encoded width imap_utf7_encode().\n\nThe server part, which is enclosed in '{' and '}', consists of the servers name or ip address, an optional port (prefixed by ':'), and an optional protocol specification (prefixed by '/').\n\nThe server part is mandatory in all mailbox parameters.\n\nAll names which start with { are remote names, and are in the form \"{\" remote_system_name [\":\" port] [flags] \"}\" [mailbox_name] where: remote_system_name - Internet domain name or bracketed IP address of server. port - optional TCP port number, default is the default port for that service flags - optional flags, see following table. mailbox_name - remote mailbox name, default is INBOX\n\nOptional flags for names Flag Description /service=service mailbox access service, default is \"imap\" /user=user remote user name for login on the server /authuser=user remote authentication user; if specified this is the user name whose password is used (e.g. administrator) /anonymous remote access as anonymous user /debug record protocol telemetry in application's debug log /secure do not transmit a plaintext password over the network /imap, /imap2, /imap2bis, /imap4, /imap4rev1 equivalent to /service=imap /pop3 equivalent to /service=pop3 /nntp equivalent to /service=nntp /norsh do not use rsh or ssh to establish a preauthenticated IMAP session /ssl use the Secure Socket Layer to encrypt the session /validate-cert validate certificates from TLS/SSL server (this is the default behavior) /novalidate-cert do not validate certificates from TLS/SSL server, needed if server uses self-signed certificates /tls force use of start-TLS to encrypt the session, and reject connection to servers that do not support it /notls do not do start-TLS to encrypt the session, even with servers that support it /readonly request read-only mailbox open (IMAP only; ignored on NNTP, and an error with SMTP and POP3)",
      ),
      array(
        'name'   => "username",
        'type'   => String,
        'desc'   => "The user name",
      ),
      array(
        'name'   => "password",
        'type'   => String,
        'desc'   => "The password associated with the username",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "The options are a bit mask with one or more of the following: OP_READONLY - Open mailbox read-only OP_ANONYMOUS - Don't use or update a .newsrc for news (NNTP only) OP_HALFOPEN - For IMAP and NNTP names, open a connection but don't open a mailbox. CL_EXPUNGE - Expunge mailbox automatically upon mailbox close (see also imap_delete() and imap_expunge()) OP_DEBUG - Debug protocol negotiations OP_SHORTCACHE - Short (elt-only) caching OP_SILENT - Don't pass up events (internal use) OP_PROTOTYPE - Return driver prototype OP_SECURE - Don't do non-secure authentication",
      ),
      array(
        'name'   => "retries",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Number of maximum connect attempts",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_ping",
    'desc'   => "imap_ping() pings the stream to see if it's still active. It may discover new mail; this is the preferred method for a periodic \"new mail check\" as well as a \"keep alive\" for servers which have inactivity timeout.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the stream is still alive, FALSE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_qprint",
    'desc'   => "Convert a quoted-printable string to an 8 bit string according to  RFC2045, section 6.7.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an 8 bits string.",
    ),
    'args'   => array(
      array(
        'name'   => "str",
        'type'   => String,
        'desc'   => "A quoted-printable string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_renamemailbox",
    'desc'   => "This function renames on old mailbox to new mailbox (see imap_open() for the format of mbox names).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "old_mbox",
        'type'   => String,
        'desc'   => "The old mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "new_mbox",
        'type'   => String,
        'desc'   => "The new mailbox name, see imap_open() for more information",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_reopen",
    'desc'   => "Reopens the specified stream to a new mailbox on an IMAP or NNTP server.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the stream is reopened, FALSE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "The options are a bit mask with one or more of the following: OP_READONLY - Open mailbox read-only OP_ANONYMOUS - Don't use or update a .newsrc for news (NNTP only) OP_HALFOPEN - For IMAP and NNTP names, open a connection but don't open a mailbox. OP_EXPUNGE - Silently expunge recycle stream CL_EXPUNGE - Expunge mailbox automatically upon mailbox close (see also imap_delete() and imap_expunge())",
      ),
      array(
        'name'   => "retries",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Number of maximum connect attempts",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_rfc822_parse_adrlist",
    'desc'   => "Parses the address string as defined in  RFC2822 and for each address.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of objects. The objects properties are:\n\nmailbox - the mailbox name (username) host - the host name personal - the personal name adl - at domain source route",
    ),
    'args'   => array(
      array(
        'name'   => "address",
        'type'   => String,
        'desc'   => "A string containing addresses",
      ),
      array(
        'name'   => "default_host",
        'type'   => String,
        'desc'   => "The default host name",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_rfc822_parse_headers",
    'desc'   => "Gets an object of various header elements, similar to imap_header().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an object similar to the one returned by imap_header(), except for the flags and other properties that come from the IMAP server.",
    ),
    'args'   => array(
      array(
        'name'   => "headers",
        'type'   => String,
        'desc'   => "The parsed headers data",
      ),
      array(
        'name'   => "defaulthost",
        'type'   => String,
        'value'  => "\"\"",
        'desc'   => "The default host name",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_rfc822_write_address",
    'desc'   => "Returns a properly formatted email address as defined in  RFC2822 given the needed information.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a string properly formatted email address as defined in  RFC2822.",
    ),
    'args'   => array(
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "host",
        'type'   => String,
        'desc'   => "The email host part",
      ),
      array(
        'name'   => "personal",
        'type'   => String,
        'desc'   => "The name of the account owner",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_savebody",
    'desc'   => "Saves a part or the whole body of the specified message.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "file",
        'type'   => Variant,
        'desc'   => "The path to the saved file as a string, or a valid file descriptor returned by fopen().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "part_number",
        'type'   => String,
        'value'  => "\"\"",
        'desc'   => "The part number. It is a string of integers delimited by period which index into a body part list as per the IMAP4 specification",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "A bitmask with one or more of the following: FT_UID - The msg_number is a UID FT_PEEK - Do not set the \\Seen flag if not already set FT_INTERNAL - The return string is in internal format, will not canonicalize to CRLF.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_scanmailbox",
    'desc'   => "Returns an array containing the names of the mailboxes that have content in the text of the mailbox.\n\nThis function is similar to imap_listmailbox(), but it will additionally check for the presence of the string content inside the mailbox data.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array containing the names of the mailboxes that have content in the text of the mailbox.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "ref",
        'type'   => String,
        'desc'   => "ref should normally be just the server specification as described in imap_open()",
      ),
      array(
        'name'   => "pattern",
        'type'   => String,
        'desc'   => "Specifies where in the mailbox hierarchy to start searching.\n\nThere are two special characters you can pass as part of the pattern: '*' and '%'. '*' means to return all mailboxes. If you pass pattern as '*', you will get a list of the entire mailbox hierarchy. '%' means to return the current level only. '%' as the pattern parameter will return only the top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in the ~/mail directory, but none in subfolders of that directory.",
      ),
      array(
        'name'   => "content",
        'type'   => String,
        'desc'   => "The searched string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_search",
    'desc'   => "This function performs a search on the mailbox currently opened in the given IMAP stream.\n\nFor example, to match all unanswered messages sent by Mom, you'd use: \"UNANSWERED FROM mom\". Searches appear to be case insensitive. This list of criteria is from a reading of the UW c-client source code and may be incomplete or inaccurate (see also  RFC2060, section 6.4.4).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of message numbers or UIDs.\n\nReturn FALSE if it does not understand the search criteria or no messages have been found.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "criteria",
        'type'   => String,
        'desc'   => "A string, delimited by spaces, in which the following keywords are allowed. Any multi-word arguments (e.g. FROM \"joey smith\") must be quoted. ALL - return all messages matching the rest of the criteria ANSWERED - match messages with the \\\\ANSWERED flag set BCC \"string\" - match messages with \"string\" in the Bcc: field BEFORE \"date\" - match messages with Date: before \"date\" BODY \"string\" - match messages with \"string\" in the body of the message CC \"string\" - match messages with \"string\" in the Cc: field DELETED - match deleted messages FLAGGED - match messages with the \\\\FLAGGED (sometimes referred to as Important or Urgent) flag set FROM \"string\" - match messages with \"string\" in the From: field KEYWORD \"string\" - match messages with \"string\" as a keyword NEW - match new messages OLD - match old messages ON \"date\" - match messages with Date: matching \"date\" RECENT - match messages with the \\\\RECENT flag set SEEN - match messages that have been read (the \\\\SEEN flag is set) SINCE \"date\" - match messages with Date: after \"date\" SUBJECT \"string\" - match messages with \"string\" in the Subject: TEXT \"string\" - match messages with text \"string\" TO \"string\" - match messages with \"string\" in the To: UNANSWERED - match messages that have not been answered UNDELETED - match messages that are not deleted UNFLAGGED - match messages that are not flagged UNKEYWORD \"string\" - match messages that do not have the keyword \"string\" UNSEEN - match messages which have not been read yet",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Valid values for options are SE_UID, which causes the returned array to contain UIDs instead of messages sequence numbers.",
      ),
      array(
        'name'   => "charset",
        'type'   => String,
        'value'  => "\"\"",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_set_quota",
    'desc'   => "Sets an upper limit quota on a per mailbox basis.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "quota_root",
        'type'   => String,
        'desc'   => "The mailbox to have a quota set. This should follow the IMAP standard format for a mailbox: user.name.",
      ),
      array(
        'name'   => "quota_limit",
        'type'   => Int64,
        'desc'   => "The maximum size (in KB) for the quota_root",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_setacl",
    'desc'   => "Sets the ACL for a giving mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "id",
        'type'   => String,
        'desc'   => "The user to give the rights to.",
      ),
      array(
        'name'   => "rights",
        'type'   => String,
        'desc'   => "The rights to give to the user. Passing an empty string will delete acl.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_setflag_full",
    'desc'   => "Causes a store to add the specified flag to the flags set for the messages in the specified sequence.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "sequence",
        'type'   => String,
        'desc'   => "A sequence of message numbers. You can enumerate desired messages with the X,Y syntax, or retrieve all messages within an interval with the X:Y syntax",
      ),
      array(
        'name'   => "flag",
        'type'   => String,
        'desc'   => "The flags which you can set are \\Seen, \\Answered, \\Flagged, \\Deleted, and \\Draft as defined by  RFC2060.",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "A bit mask that may contain the single option: ST_UID - The sequence argument contains UIDs instead of sequence numbers",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_sort",
    'desc'   => "Gets and sorts message numbers by the given parameters.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of message numbers sorted by the given parameters.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "criteria",
        'type'   => Int64,
        'desc'   => "Criteria can be one (and only one) of the following: SORTDATE - message Date SORTARRIVAL - arrival date SORTFROM - mailbox in first From address SORTSUBJECT - message subject SORTTO - mailbox in first To address SORTCC - mailbox in first cc address SORTSIZE - size of message in octets",
      ),
      array(
        'name'   => "reverse",
        'type'   => Int64,
        'desc'   => "Set this to 1 for reverse sorting",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "The options are a bitmask of one or more of the following: SE_UID - Return UIDs instead of sequence numbers SE_NOPREFETCH - Don't prefetch searched messages",
      ),
      array(
        'name'   => "search_criteria",
        'type'   => String,
        'value'  => "\"\"",
      ),
      array(
        'name'   => "charset",
        'type'   => String,
        'value'  => "\"\"",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_status",
    'desc'   => "Gets status information about the given mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "This function returns an object containing status information. The object has the following properties: messages, recent, unseen, uidnext, and uidvalidity.\n\nflags is also set, which contains a bitmask which can be checked against any of the above constants.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Valid flags are: SA_MESSAGES - set \$status->messages to the number of messages in the mailbox SA_RECENT - set \$status->recent to the number of recent messages in the mailbox SA_UNSEEN - set \$status->unseen to the number of unseen (new) messages in the mailbox SA_UIDNEXT - set \$status->uidnext to the next uid to be used in the mailbox SA_UIDVALIDITY - set \$status->uidvalidity to a constant that changes when uids for the mailbox may no longer be valid SA_ALL - set all of the above",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_subscribe",
    'desc'   => "Subscribe to a new mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_thread",
    'desc'   => "Gets a tree of a threaded message.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "imap_thread() returns an associative array containing a tree of messages threaded by REFERENCES, or FALSE on error.\n\nEvery message in the current mailbox will be represented by three entries in the resulting array:\n\n\$thread[\"XX.num\"] - current message number\n\n\$thread[\"XX.next\"]\n\n\$thread[\"XX.branch\"]",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "options",
        'type'   => Int64,
        'value'  => "0",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_timeout",
    'desc'   => "Sets or fetches the imap timeout.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "If the timeout parameter is set, this function returns TRUE on success and FALSE on failure.\n\nIf timeout is not provided or evaluates to -1, the current timeout value of timeout_type is returned as an integer.",
    ),
    'args'   => array(
      array(
        'name'   => "timeout_type",
        'type'   => Int64,
        'desc'   => "One of the following: IMAP_OPENTIMEOUT, IMAP_READTIMEOUT, IMAP_WRITETIMEOUT, or IMAP_CLOSETIMEOUT.",
      ),
      array(
        'name'   => "timeout",
        'type'   => Int64,
        'value'  => "-1",
        'desc'   => "The timeout, in seconds.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_uid",
    'desc'   => "This function returns the UID for the given message sequence number. An UID is a unique identifier that will not change over time while a message sequence number may change whenever the content of the mailbox changes.\n\nThis function is the inverse of imap_msgno().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "The UID of the given message.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => Int64,
        'desc'   => "The message number.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_undelete",
    'desc'   => "Removes the deletion flag for a specified message, which is set by imap_delete() or imap_mail_move().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "msg_number",
        'type'   => String,
        'desc'   => "The message number",
      ),
      array(
        'name'   => "flags",
        'type'   => Int64,
        'value'  => "0",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_unsubscribe",
    'desc'   => "Unsubscribe from the specified mailbox.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "imap_stream",
        'type'   => Object,
        'desc'   => "An IMAP stream returned by imap_open().",
      ),
      array(
        'name'   => "mailbox",
        'type'   => String,
        'desc'   => "The mailbox name, see imap_open() for more information",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_utf7_decode",
    'desc'   => "Decodes modified UTF-7 text into ISO-8859-1 string.\n\nThis function is needed to decode mailbox names that contain certain characters which are not in range of printable ASCII characters.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a string that is encoded in ISO-8859-1 and consists of the same sequence of characters in text, or FALSE if text contains invalid modified UTF-7 sequence or text contains a character that is not part of ISO-8859-1 character set.",
    ),
    'args'   => array(
      array(
        'name'   => "text",
        'type'   => String,
        'desc'   => "A modified UTF-7 encoding string, as defined in  RFC 2060, section 5.1.3 (original UTF-7 was defined in  RFC1642).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_utf7_encode",
    'desc'   => "Converts data to modified UTF-7 text.\n\nThis is needed to encode mailbox names that contain certain characters which are not in range of printable ASCII characters.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns data encoded with the modified UTF-7 encoding as defined in  RFC 2060, section 5.1.3 (original UTF-7 was defined in  RFC1642).",
    ),
    'args'   => array(
      array(
        'name'   => "data",
        'type'   => String,
        'desc'   => "An ISO-8859-1 string.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "imap_utf8",
    'desc'   => "Converts the given mime_encoded_text to UTF-8.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an UTF-8 encoded string.",
    ),
    'args'   => array(
      array(
        'name'   => "mime_encoded_text",
        'type'   => String,
        'desc'   => "A MIME encoded string. MIME encoding method and the UTF-8 specification are described in  RFC2047 and  RFC2044 respectively.",
      ),
    ),
  ));


///////////////////////////////////////////////////////////////////////////////
// Classes
//
// BeginClass
// array (
//   'name'   => name of the class
//   'desc'   => description of the class's purpose
//   'flags'  => attributes of the class, see base.php for possible values
//   'note'   => additional note about this class's schema
//   'parent' => parent class name, if any
//   'ifaces' => array of interfaces tihs class implements
//   'bases'  => extra internal and special base classes this class requires
//   'footer' => extra C++ inserted at end of class declaration
// )
//
// DefineConstant(..)
// DefineConstant(..)
// ...
// DefineFunction(..)
// DefineFunction(..)
// ...
// DefineProperty
// DefineProperty
//
// array (
//   'name'  => name of the property
//   'type'  => type of the property
//   'flags' => attributes of the property
//   'desc'  => description of the property
//   'note'  => additional note about this property's schema
// )
//
// EndClass()

